package edu.uoc.zonefeed;

import javax.persistence.Id;
import com.google.appengine.api.users.User;
import com.googlecode.objectify.Key;

public class Comment {
  public final static int TEXT = 0;
  public final static int LINK = 1;
  public final static int IMAGE = 2;
  public final static int VIDEO = 3;
  
  @Id Long id;
  long created;
  
  String text;
  
  int type;
  
  String title;
  String link;
  
  Key<StoredImage> image;
  int imageWidth = 0;
  int imageHeight = 0;
  
  Key<Comment> parent;
  Key<Story> story;
  
  User author;
  
  int positiveVotes = 0;
  int negativeVotes = 0;
  
  public long getId() {
	  return id;
  }
  
  public String getText() {
	  return text;
  }
  
  public void setText(String text) {
	  this.text = text;
  }
  
  public User getAuthor() {
	  return author;
  }
  
  public void setAuthor(User author) {
	  this.author = author;
  }
  
  public long getCreated() {
	  return created;
  }
	
  public void setCreated(long created) {
	  this.created = created;
  }

  public void setStory(long id) {
	  this.story = new Key<Story>(Story.class, id);
  }
  
  public int getType() {
	  return type;
  }
  
  public void setType(int type) {
	  this.type = type;
  }
  
  public String getTitle() {
	  return title;
  }
  
  public void setTitle(String title) {
	  this.title = title;
  }
  
  public String getLink() {
	  return link;
  }
  
  public void setLink(String link) {
	  this.link = link;
  }
  
  public Key<StoredImage> getImage() {
	  return image;
  }
  
  public void setImage(Key<StoredImage> image) {
	  this.image = image;
  }
  
  public int getImageWidth() {
	  return imageWidth;
  }
  
  public void setImageWidth(int imageWidth) {
	  this.imageWidth = imageWidth;
  }
  
  public int getImageHeight() {
	  return imageHeight;
  }
  
  public void setImageHeight(int imageHeight) {
	  this.imageHeight = imageHeight;
  }
  
  public int getPositiveVotes() {
	  return positiveVotes;
  }
  
  public void setPositiveVotes(int positiveVotes) {
	  this.positiveVotes = positiveVotes;
  }
  
  public int getNegativeVotes() {
	  return negativeVotes;
  }
  
  public void setNegativeVotes(int negativeVotes) {
	  this.negativeVotes = negativeVotes;
  }
}
