package edu.uoc.zonefeed;

import java.util.Iterator;
import java.util.AbstractCollection;
import java.util.Date;
import java.util.List;
import java.util.ArrayList;

public class Utils {
	public static String join(AbstractCollection<String> s, String delimiter) {
	    if (s.isEmpty()) return "";
	    Iterator<String> iter = s.iterator();
	    StringBuffer buffer = new StringBuffer(iter.next());
	    while (iter.hasNext()) {
	        buffer.append(delimiter);
	        buffer.append(iter.next());
	    }
	    return buffer.toString();
	}
	
	public static String join(String[] s, String delimiter) {
	    if (s.length == 0) return "";
	    StringBuffer buffer = new StringBuffer(s[0]);
	    for (int c=1;c<s.length;c++) {
	        buffer.append(delimiter);
	        buffer.append(s[c]);
	    }
	    return buffer.toString();
	}
	
	private static List<CategoryEntry> convertCategoryNodeToEntries(CategoryNode node, int currentLevel) {
		List<CategoryEntry> result = new ArrayList<CategoryEntry>();
		
		CategoryEntry newEntry = new CategoryEntry(node.getValue(), node.getDescription(), currentLevel);
		result.add(newEntry);
		
		CategoryNode[] nodes = node.getChildren();
		
		for (CategoryNode currentNode: nodes) {
			result.addAll(Utils.convertCategoryNodeToEntries(currentNode, currentLevel+1));
		}
		
		return result;
	}
	
	public static List<CategoryEntry> convertCategoryNodeToEntries(CategoryNode rootNode) {
		List<CategoryEntry> result = new ArrayList<CategoryEntry>();
		
		CategoryNode[] nodes = rootNode.getChildren();
		
		for (CategoryNode node: nodes) {
			result.addAll(Utils.convertCategoryNodeToEntries(node, 0));
		}
			
		return result;
	}
	
	public static String readableDate(long timestamp) {
		long diff = (new Date()).getTime() - timestamp;
		
		diff /= 1000;
		
try {
		
		if (diff < 60) {
			return "seconds ago";
		} else {
			diff /= 60;
			
			if (diff < 60) {
				if (diff == 1) {
					return "a minute ago";
				} else {
					return "" + diff + " minutes ago";
				}
			} else {
				diff /= 60;
				
				if (diff < 24) {
					if (diff == 1) {
						return "an hour ago";
					} else {
						return "" + diff + " hours ago";
					}
				} else {
					diff /= 24;
					if (diff < 365) {
						if (diff == 1) {
							return "a day ago";
						} else {
							return "" + diff + " days ago";
						}
					}  else {
						diff /= 365;
						
						if (diff == 1) {
							return "a year ago";
						} else {
							return "" + diff + " years ago";
						}
					}
				}
			}
		}
} catch (Exception ex) {
	ex.printStackTrace();
}
return "Error";
	}

}
