<%@ page import='java.util.Date' %>
<%@ page import='java.util.List' %>
<%@ page import='java.util.ArrayList' %>
<%@ page import='java.util.Arrays' %>
<%@ page import='java.util.HashSet' %>
<%@ page import='java.util.Enumeration' %>
<%@ page import='edu.uoc.zonefeed.*' %>
<%@ page import='com.googlecode.objectify.Key' %>
<%@ page import='com.google.appengine.api.users.UserService' %>
<%@ page import='com.google.appengine.api.users.UserServiceFactory' %>
<%@ taglib uri='/WEB-INF/tlds/template.tld' prefix='template' %>
<%
UserService userService = UserServiceFactory.getUserService();
long newId = 0;
if (userService.isUserLoggedIn()) {
	Story newStory = new Story();
	newStory.setAuthor(userService.getCurrentUser());
	newStory.setTitle(request.getParameter("title"));
	newStory.setDescription(request.getParameter("description"));
	newStory.setCreated((new Date()).getTime());
	newStory.setModified(newStory.getCreated());
	newStory.setEntries(0);
	// Get category
	boolean foundNull = false;
	int currentCategory = 1;
	HashSet<String> fullCategories = new HashSet<String>();
	HashSet<String> categories = new HashSet<String>();
	
	while (!foundNull) {
		String categoryParam = request.getParameter("category" + currentCategory);
		if (categoryParam != null) {
			if (categoryParam.length() > 0) {
				fullCategories.add(categoryParam);
				ArrayList<String> parts = new ArrayList<String>(Arrays.asList(categoryParam.split("/")));
				
				while (parts.size() > 0) {
					categories.add(Utils.join(parts, "/"));
					parts.remove(parts.size() - 1);
				}
			}
		} else {
			foundNull = true;
		}
		currentCategory++;
	}
	newStory.setCategory(new ArrayList<String>(categories));
	newStory.setFullCategory(new ArrayList<String>(fullCategories));
	newId = Persistance.getInstance().storeStory(newStory);
	
	// Create properties
	Enumeration<String> names = (Enumeration<String>)request.getParameterNames();
	while (names.hasMoreElements()) {
		String current = names.nextElement();
		if (current.indexOf("property-") == 0) {
			String currentProperty = current.substring("property-".length());
			Property newProperty = new Property();
			newProperty.setStory(new Key<Story>(Story.class, newId));
			newProperty.setName(currentProperty);
			newProperty.setValue(request.getParameter(current));
			Persistance.getInstance().storeProperty(newProperty);
		}
	}
	
}
request.setAttribute("edu.uoc.zonefeed.title", "Story Created");
request.setAttribute("edu.uoc.zonefeed.content", "Your story has been successfully published in our system.");
request.setAttribute("edu.uoc.zonefeed.link", "/viewstory?id=" + newId);
request.setAttribute("edu.uoc.zonefeed.linktitle", "Click here to open it.");
%>
<template:insert template='/base.jsp'>
  <template:put name='title' content='Story Created'/>
  <template:put name='content' content='/genericcontent.jsp' include='true' />
</template:insert>
