<%@ page import='edu.uoc.zonefeed.*' %><%@ 
page import='com.googlecode.objectify.Key' %><%@ 
page import='com.google.appengine.api.images.*' %><%@ 
page import='com.google.appengine.api.users.UserService' %><%@ 
page import='com.google.appengine.api.users.UserServiceFactory' %><%@ 
page import='com.google.appengine.api.datastore.Blob' %><%@ 
page import='org.apache.commons.io.IOUtils' %><%@ 
page import='org.apache.commons.fileupload.FileItemStream' %><%@ 
page import='org.apache.commons.fileupload.FileItemIterator' %><%@ 
page import='org.apache.commons.fileupload.servlet.ServletFileUpload' %><%@ 
page import='java.io.InputStream' %><%@ 
page import='java.io.ByteArrayOutputStream' %><%@ 
taglib uri='/WEB-INF/tlds/template.tld' prefix='template' %><%
UserService userService = UserServiceFactory.getUserService();
if (!userService.isUserLoggedIn()) {
  response.sendRedirect(userService.createLoginURL("/cp"));
}

String screenName = null;
byte[] imageData = null;
String imageContentType = null;

// Read parameters
ServletFileUpload upload = new ServletFileUpload();
FileItemIterator iter = upload.getItemIterator(request);

int counter = 0;
while (iter.hasNext()) {
  FileItemStream imageItem = iter.next();
  if (imageItem.getFieldName().equals("screenname")) {
      InputStream stream = imageItem.openStream();
      // Read the file into a byte array.
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      byte[] buf = new byte[8192];
      int len = 0;
      while(-1 != (len=stream.read(buf))) {
    	  baos.write(buf, 0, len);
      }
      screenName = baos.toString();
  } else if (imageItem.getFieldName().equals("avatar")) {
	  InputStream imgStream = imageItem.openStream();
	  imageData = IOUtils.toByteArray(imgStream);
	  if (imageData.length < 1) {
		  imageData = null;
	  }
	  imageContentType = imageItem.getContentType();
  }
}

if ((screenName == null) || (screenName.length() == 0)) {
	request.setAttribute("edu.uoc.zonefeed.errormessage", "Please specify a screen name.");
} else {
	// Ensure no other registered user with same screen name
	RegisteredUser reg = Persistance.getInstance().getRegisteredUserByScreenName(request.getParameter("screenname"));
	
	if (reg != null) {
		request.setAttribute("edu.uoc.zonefeed.errormessage", "A user with the same screen name exists, please choose a different one.");
	} else {
		Blob imageBlob = null;
		
		boolean badImage = false;
	    if (imageData != null) {
	    	try {
			    ImagesService imagesService = ImagesServiceFactory.getImagesService();
			    
			    Image oldImage = ImagesServiceFactory.makeImage(imageData);
			    
			    if ((oldImage.getWidth() != 48) || (oldImage.getHeight() != 48)) {
				    CompositeTransform transforms = ImagesServiceFactory.makeCompositeTransform();
				    
				    if (oldImage.getHeight() > oldImage.getWidth()) {
				    	double margin = (double)(oldImage.getHeight()-oldImage.getWidth())/2*oldImage.getHeight();
					    Transform crop = ImagesServiceFactory.makeCrop(0.0, margin, 1.0, 1 - margin);
					    transforms.concatenate(crop);
				    } else if (oldImage.getWidth() > oldImage.getHeight()) {
				    	double margin = ((double)(oldImage.getWidth()-oldImage.getHeight()))/(2*oldImage.getWidth());
					    Transform crop = ImagesServiceFactory.makeCrop(margin, 0.0, 1 - margin, 1.0);
					    transforms.concatenate(crop);
				    }
				    Transform resize = ImagesServiceFactory.makeResize(48, 48);
				    transforms.concatenate(resize);
					
				    
				    Image newImage = imagesService.applyTransform(transforms, oldImage);
				
				    imageData = newImage.getImageData();
			    }
			    
			    imageBlob = new Blob(imageData);
	    	} catch (Exception ex) {
	    		ex.printStackTrace();
	    		// Problem processing the sent image
	    		badImage = true;
	    	}
	    }
	    if (badImage) {
	    	request.setAttribute("edu.uoc.zonefeed.errormessage", "Couldn't process the sent image, please retry or leave blank.");
	    } else {
	    	reg = new RegisteredUser();
	    	
	    	reg.setEmail(userService.getCurrentUser().getEmail());
	    	
	    	// Store image if necessary
	    	if (imageBlob != null) {
	    		StoredImage stored = new StoredImage();
	    		stored.setImage(imageBlob);
	    		stored.setContentType(imageContentType);
	    		Key<StoredImage> imageKey = Persistance.getInstance().storeImage(stored);
	    		
	    		reg.setAvatar(imageKey);
	    	}
	    	
	    	reg.setScreenName(screenName);
	    	Persistance.getInstance().storeUser(reg);
	    	
	    	// Everything fine, redirect to /cp
	    	response.sendRedirect("/cp");
	    }
	}
}
request.setAttribute("edu.uoc.zonefeed.screenname", screenName);
%>
<template:insert template='/base.jsp'>
  <template:put name='title' content='Register'/>
  <template:put name='content' content='/registercontent.jsp' include='true'/>
</template:insert>
