<%@ page import='java.util.Date' %>
<%@ page import='edu.uoc.zonefeed.*' %>
<%@ page import='com.google.appengine.api.users.UserService' %>
<%@ page import='com.google.appengine.api.users.UserServiceFactory' %>
<%@ taglib uri='/WEB-INF/tlds/template.tld' prefix='template' %>
<%
UserService userService = UserServiceFactory.getUserService();
if (userService.isUserLoggedIn()) {
	long storyId = Long.parseLong(request.getParameter("story"));
	Story story = Persistance.getInstance().getStory(storyId);
	if (story != null) {
		Comment newComment = new Comment();
		newComment.setAuthor(userService.getCurrentUser());
		newComment.setText(request.getParameter("content"));
		String type = request.getParameter("type");
		if (type.equals("text")) {
			newComment.setType(Comment.TEXT);
		} else if (type.equals("video")) {
			// Extract video
			String video = request.getParameter("video");
			if (video.indexOf("v=") > 0) {
				int startPos = video.indexOf("v=") + 2;
				int endPos = video.indexOf("&", startPos);
				if (endPos < 0) {
					// Not found
 					video = video.substring(startPos);
				} else {
					video = video.substring(startPos, endPos);
				}
			}
			newComment.setLink(video);
			newComment.setType(Comment.VIDEO);
		} else if (type.equals("link")) {
			newComment.setLink(request.getParameter("link"));
			newComment.setTitle(request.getParameter("title"));
			newComment.setType(Comment.LINK);
		}
		newComment.setCreated((new Date()).getTime());
		newComment.setStory(storyId);
		Persistance.getInstance().storeComment(newComment);
		story.setEntries(story.getEntries() + 1);
		story.setModified((new Date()).getTime());
		Persistance.getInstance().storeStory(story);
	}
}

request.setAttribute("edu.uoc.zonefeed.title", "Post successfully saved");
request.setAttribute("edu.uoc.zonefeed.content", "Your post has been successfully published in our system.");
request.setAttribute("edu.uoc.zonefeed.link", "/viewstory?id=" + request.getParameter("story"));
request.setAttribute("edu.uoc.zonefeed.linktitle", "Click here to go back to the story.");
%>
<template:insert template='/base.jsp'>
  <template:put name='title' content='Success'/>
  <template:put name='content' content='/genericcontent.jsp' include='true'/>
</template:insert>
