<%@ page import='java.util.Date' %>
<%@ page import='com.googlecode.objectify.Key' %>
<%@ page import='edu.uoc.zonefeed.*' %>
<%@ page import='com.google.appengine.api.users.UserService' %>
<%@ page import='com.google.appengine.api.users.UserServiceFactory' %>
<%@ page import='com.google.appengine.api.images.*' %>
<%@ page import='com.google.appengine.api.datastore.Blob' %>
<%@ page import='org.apache.commons.io.IOUtils' %>
<%@ page import='org.apache.commons.fileupload.FileItemStream' %>
<%@ page import='org.apache.commons.fileupload.FileItemIterator' %>
<%@ page import='org.apache.commons.fileupload.servlet.ServletFileUpload' %>
<%@ page import='java.io.InputStream' %>
<%@ page import='java.io.ByteArrayOutputStream' %>
<%@ taglib uri='/WEB-INF/tlds/template.tld' prefix='template' %>
<%
UserService userService = UserServiceFactory.getUserService();
long storyId = 0;
if (userService.isUserLoggedIn()) {
	String screenName = null;
	byte[] imageData = null;
	String imageContentType = null;
	int imageWidth = 0;
	int imageHeight = 0;
	String content = "";

	// Read parameters
	ServletFileUpload upload = new ServletFileUpload();
	FileItemIterator iter = upload.getItemIterator(request);

	int counter = 0;
	while (iter.hasNext()) {
	  FileItemStream imageItem = iter.next();
	  if (imageItem.getFieldName().equals("content")) {
	      InputStream stream = imageItem.openStream();
	      // Read the file into a byte array.
	      ByteArrayOutputStream baos = new ByteArrayOutputStream();
	      byte[] buf = new byte[8192];
	      int len = 0;
	      while(-1 != (len=stream.read(buf))) {
	    	  baos.write(buf, 0, len);
	      }
	      content = baos.toString();
	  } else if (imageItem.getFieldName().equals("story")) {
	      InputStream stream = imageItem.openStream();
	      // Read the file into a byte array.
	      ByteArrayOutputStream baos = new ByteArrayOutputStream();
	      byte[] buf = new byte[8192];
	      int len = 0;
	      while(-1 != (len=stream.read(buf))) {
	    	  baos.write(buf, 0, len);
	      }
	      storyId = Long.parseLong(baos.toString());
	  } else if (imageItem.getFieldName().equals("image")) {
		  InputStream imgStream = imageItem.openStream();
		  imageData = IOUtils.toByteArray(imgStream);
		  imageContentType = imageItem.getContentType();
	  }
	}
	
	Story story = Persistance.getInstance().getStory(storyId);
	if (story != null) {
		Comment newComment = new Comment();
		newComment.setAuthor(userService.getCurrentUser());
		newComment.setText(content);
		newComment.setType(Comment.IMAGE);
		newComment.setCreated((new Date()).getTime());
		newComment.setStory(storyId);
		
		// Handle image
		Blob imageBlob = null;
		
		boolean badImage = false;
	    if (imageData != null) {
	    	try {
			    ImagesService imagesService = ImagesServiceFactory.getImagesService();
			    
			    Image oldImage = ImagesServiceFactory.makeImage(imageData);
			    
			    imageWidth = oldImage.getWidth();
			    imageHeight = oldImage.getHeight();
			    if ((imageWidth > 500) || (imageHeight > 500)) {
				    CompositeTransform transforms = ImagesServiceFactory.makeCompositeTransform();
				    
				    Transform resize = ImagesServiceFactory.makeResize(500, 500);
				    transforms.concatenate(resize);
					
				    
				    Image newImage = imagesService.applyTransform(transforms, oldImage);
					
				    imageWidth = newImage.getWidth();
				    imageHeight = newImage.getHeight();
				    imageData = newImage.getImageData();
			    }
			    
			    imageBlob = new Blob(imageData);
	    	} catch (Exception ex) {
	    		ex.printStackTrace();
	    		// Problem processing the sent image
	    		badImage = true;
	    	}
	    }
	    
    	// Store image if necessary
    	if (imageBlob != null) {
    		StoredImage stored = new StoredImage();
    		stored.setImage(imageBlob);
    		stored.setContentType(imageContentType);
    		newComment.setImageWidth(imageWidth);
    		newComment.setImageHeight(imageHeight);
    		Key<StoredImage> imageKey = Persistance.getInstance().storeImage(stored);
    		
    		newComment.setImage(imageKey);
    	}
		
		
		Persistance.getInstance().storeComment(newComment);
		story.setEntries(story.getEntries() + 1);
		story.setModified((new Date()).getTime());
		Persistance.getInstance().storeStory(story);
	}
}

request.setAttribute("edu.uoc.zonefeed.title", "Post successfully saved");
request.setAttribute("edu.uoc.zonefeed.content", "Your post has been successfully published in our system.");
request.setAttribute("edu.uoc.zonefeed.link", "/viewstory?id=" + storyId);
request.setAttribute("edu.uoc.zonefeed.linktitle", "Click here to go back to the story.");
%>
<template:insert template='/base.jsp'>
  <template:put name='title' content='Success'/>
  <template:put name='content' content='/genericcontent.jsp' include='true'/>
</template:insert>
