<%@ page import='com.google.appengine.api.users.UserService' %>
<%@ page import='com.google.appengine.api.users.UserServiceFactory' %>
<%@ page import='edu.uoc.zonefeed.*' %>
<%@ page import='java.util.Map' %>
<%
String filter = (String)request.getAttribute("edu.uoc.zonefeed.filter");

Story[] result = new Story[0];

String title = "Stories";

UserService userService = UserServiceFactory.getUserService();

if (filter.equals("own")) {
	if (userService.isUserLoggedIn()) {
		result = Persistance.getInstance().getUserStories(userService.getCurrentUser());
	}
	title = "My Stories";
} else if (filter.equals("category")) {
	String param = (String)request.getAttribute("edu.uoc.zonefeed.param");
	result = Persistance.getInstance().getCategoryStories(param);
	String[] parts = param.split("/");
	title = "Stories for Category " + Utils.join(parts, " &raquo; ");
} else if (filter.equals("updated")) {
	result = Persistance.getInstance().getActiveStories();
	title = "Recently Updated";
} else if (filter.equals("property")) {
	@SuppressWarnings("unchecked")
	Map<String,String> param = (Map<String,String>)request.getAttribute("edu.uoc.zonefeed.param");
	result = Persistance.getInstance().searchProperties(param);
	title = "Search Properties Result";
}
%>
<div class="post">
	<h2 class="title"><%= title %>
<%
if (filter.equals("category")) {
%>
	 <span class="feed"><a href="/catrdf?name=<%= request.getAttribute("edu.uoc.zonefeed.param") %>">Subscribe</a></span>
<%
}
%>
	</h2>
	<div class="entry">
	<%
	if (result.length>0) {
	%>
	<table style="width: 100%;">
	<thead>
	<tr>
	<th class="first-col">Story</th>
	<th>Entries</th>
	<th>Created</th>
	<th>Updated</th>
	</tr>
	</thead>
	<tbody>
	<%
		for (int c=0;c<result.length;c++) {
			String trclass;
			if (c%2 == 0) {
				trclass = "even";
			} else {
				trclass = "odd";
			}
	%>
	<tr class="<%= trclass %>">
	<td class="first-col"><a href="/viewstory?id=<%= result[c].getId() %>"><%= result[c].getTitle() %></a>
	<%
			if  ((result[c].getDescription() != null) && (result[c].getDescription().length() > 0)) {
				%>
				<br/><span class="description"><%= result[c].getDescription() %></span>
				<%
			}
	%>
	</td>
	<td><%= result[c].getEntries() %></td>
	<td><%= Utils.readableDate(result[c].getCreated()) %></td>
	<td><%= Utils.readableDate(result[c].getModified()) %></td>
	</tr>
	<%
		}
	%>
	</tbody>
	</table>
	<%
	} else {
		%>
		<div style="text-align: middle;"><em>No stories found</em></div>
		<%
	}
	if (userService.isUserLoggedIn()) {
		String categoryText = "";
		String createStoryLabel = "Create new story";
		if (filter.equals("category")) {
			String param = (String)request.getAttribute("edu.uoc.zonefeed.param");
			categoryText = "?category=" + param;
			createStoryLabel = "Create new story in this category";
		}
	%>
	<div style="margin-top: 20px;"><a href="/createstory<%= categoryText %>"><%= createStoryLabel %></a></div>
	<%
	}
	%>
	</div>
</div>
