<%@ page import='edu.uoc.zonefeed.*' %>
<%@ page import='java.util.List' %>
<%@ page import='java.util.Iterator' %>
<%@ page import='com.google.appengine.api.users.UserService' %>
<%@ page import='com.google.appengine.api.users.UserServiceFactory' %>
<%
Long id = (Long)request.getAttribute("edu.uoc.zonefeed.story");
Story story = Persistance.getInstance().getStory((long)id);
Comment[] comments = Persistance.getInstance().getStoryComments((long)id);
%>
<script>
$(document).ready(function(){
	$(".voteup").click(function (e) {
		e.preventDefault();
		$(this).parents(".votes").load("/vote?type=up&id=" + $(this).parents(".comment").attr("data-id"));
		$(this).parents(".votelinks").html("<em>Sending...</em>");
	});
	$(".votedown").click(function (e) {
		e.preventDefault();
		$(this).parents(".votes").load("/vote?type=down&id=" + $(this).parents(".comment").attr("data-id"));
		$(this).parents(".votelinks").html("<em>Sending...</em>");
	});
});
</script>
<div class="post">
	<h2 class="title" style="margin-bottom: 5px;"><%= story.getTitle() %> <span class="timestamp">Started <%= Utils.readableDate(story.getCreated()) %></span> <span class="feed"><a href="/storyrdf?id=<%= id %>">Subscribe</a></span></h2>
	<div class="entry" style="margin-bottom: 15px;">
    <%= story.getDescription() %>
    </div>
    <div><b>Categories:</b> 
    <%
    boolean isFirst = true;
    
    if (story.getFullCategory() != null) {
	    for (String category: story.getFullCategory()) {
			if (!isFirst) {
				out.print(" , ");
			} else {
				isFirst = false;
			}
			
	    	int pos = -1;
	    	
	    	boolean isCategoryFirst = true;
	    	do {
	        	pos = category.indexOf("/", pos+1);
	    		if (!isCategoryFirst) {
	    			out.print(" &rsaquo; ");
	    		} else {
	    			isCategoryFirst = false;
	    		}
	    		String substring;
	    		if (pos >= 0) {
		    		substring = category.substring(0, pos);
	    		} else {
	    			substring = category;
	    		}
	    		String[] parts = substring.split("/");
    %>
    <a href="/viewcategory?name=<%= substring %>"><%= parts[parts.length-1] %></a>
    <%
	    	} while (pos > -1);
    	}
    }
    %>
    </div>
    <div><b>Properties:</b></div>
    <ul>
    <%
    List<Property> properties = Persistance.getInstance().getStoryProperties(id);
    
    if (properties.size() == 0) {
    %>
    <li><em>No properties</em></li>	
    <%
    } else {
    	Iterator<Property> entries = properties.iterator();
    	
    	while (entries.hasNext()) {
    		Property entry = entries.next();
    	    %>
    	    <li><b><%= entry.getName() %>:</b> <%= entry.getValue() %></li>	
    	    <%
    	}
    }
    %>
    </ul>
    <%
    UserService userService = UserServiceFactory.getUserService();

    for (Comment comment: comments) {
    	try {
    	RegisteredUser user = Persistance.getInstance().getRegisteredUser(comment.getAuthor().getEmail());
    	String avatar;
    	
    	if ((user != null) && (user.getAvatar() != null)) {
	    	avatar = "/image/" + user.getAvatar().getId();
    	} else {
    		avatar = "/res/avatar.png";
    	}
    	String votesUp = "0";
    	String votesDown = "0";
    	if (comment.getPositiveVotes() > 0) {
    		votesUp = "+" + comment.getPositiveVotes();
    	}
    	if (comment.getNegativeVotes() > 0) {
    		votesDown = "-" + comment.getNegativeVotes();
    	}
    	
    	String screenName;
    	if (user != null) {
    		screenName = user.getScreenName();
    	} else {
    		screenName = comment.getAuthor().getNickname();
    	}
    %>
    <div class="comment" data-id="<%= comment.getId() %>">
    <div class="commentavatar"><img src="<%= avatar %>" width="48" height="48" /></div>
    <div class="commentauthor"><%= screenName %> <span class="timestamp">Published <%= Utils.readableDate(comment.getCreated()) %></span> <span class="votes"><span class="votesup"><%= votesUp %></span> <span class="votesdown"><%= votesDown %></span>
    <%
    if (userService.isUserLoggedIn()) {
    %>
    <span class="votelinks">
    <a href="#" class="voteup">Vote Up</a>
    <a href="#" class="votedown">Vote Down</a>
    </span>
    <%
    }
    %>
    </span>
    </div>
    <%
    if (comment.getType() == Comment.LINK) {
    	String linkTitle = comment.getLink();
    	if ((comment.getTitle() != null) && (comment.getTitle().length() > 0)) {
    		linkTitle = comment.getTitle();
    	}
    %>
    <div class="commentlink"><a href="<%= comment.getLink() %>"><%= linkTitle %></a></div>
    <% 
    } else if (comment.getType() == Comment.VIDEO) {
    %>
    <div class="commentvideo">
    <object width="425" height="344">
    <param name="movie" value="http://www.youtube.com/v/<%= comment.getLink() %>?fs=1">
    <param name="allowFullScreen" value="true">
    <param name="allowScriptAccess" value="always">
    <embed src="http://www.youtube.com/v/<%= comment.getLink() %>?fs=1"
      type="application/x-shockwave-flash"
      allowfullscreen="true"
      allowscriptaccess="always"
      width="425" height="344">
    </embed>
    </object>
    </div>
    <% 
    } else if (comment.getType() == Comment.IMAGE) {
    %>
    <div class="commentimage"><img src="/image/<%= comment.getImage().getId() %>" width="<%= comment.getImageWidth() %>" height="<%= comment.getImageHeight() %>" /></div>
    <% 
    }
    if ((comment.getText() != null) && (comment.getText().length() > 0)) {
    %>
    <div class="commenttext"><%= comment.getText() %></div>
    <%
    }
    %>
    </div>
    <%
    	} catch (Exception ex) {
    		ex.printStackTrace();
    	}
    }
    %>
    <%
    if (userService.isUserLoggedIn()) {
    %>
	<div id="tabs">
		<ul>
			<li><a href="#tabs-text">Text</a></li>
			<li><a href="#tabs-link">Link</a></li>
			<li><a href="#tabs-image">Image</a></li>
			<li><a href="#tabs-video">Video</a></li>
		</ul>
		<div id="tabs-text">
		    <form method="POST" action="/postcomment">
		    <input type="hidden" name="story" value="<%= id %>">
		    <input type="hidden" name="type" value="text">
		    <div class="formlabel"><label for="video">Comment</label></div>
		    <div><textarea name="content"></textarea></div>
		    <div class="formlabel"><input type="submit" value="Send"></div>
		    </form>
	    </div>
		<div id="tabs-link">
		    <form method="POST" action="/postcomment">
		    <input type="hidden" name="story" value="<%= id %>">
		    <input type="hidden" name="type" value="link">
		    <div class="formlabel"><label for="link">Link</label></div>
		    <div><input type="text" name="link" value="http://"></div>
		    <div class="formlabel"><label for="title">Title</label> <span class="optional">(optional)</span></div>
		    <div><input type="text" name="title"></div>
		    <div class="formlabel"><label for="video">Description</label> <span class="optional">(optional)</span></div>
		    <div><textarea name="content"></textarea></div>
		    <div class="formlabel"><input type="submit" value="Send"></div>
		    </form>
	    </div>
		<div id="tabs-image">
		    <form method="POST" action="/postimagecomment" enctype="multipart/form-data">
		    <input type="hidden" name="story" value="<%= id %>">
		    <div class="formlabel"><label for="image">Image</label></div>
		    <div><input type="file" name="image"></div>
		    <div class="formlabel"><label for="content">Description</label> <span class="optional">(optional)</span></div>
		    <div><textarea name="content"></textarea></div>
		    <div class="formlabel"><input type="submit" value="Send"></div>
		    </form>
	    </div>
		<div id="tabs-video">
		    <form method="POST" action="/postcomment">
		    <input type="hidden" name="story" value="<%= id %>">
		    <input type="hidden" name="type" value="video">
		    <div class="formlabel"><label for="video">Video</label> <span class="optional">(YouTube video ID or URL)</span></div>
		    <div><input type="text" name="video"></div>
		    <div class="formlabel"><label for="video">Description</label> <span class="optional">(optional)</span></div>
		    <div><textarea name="content"></textarea></div>
		    <div class="formlabel"><input type="submit" value="Send"></div>
		    </form>
	    </div>
	</div>
    <%
    }
    %>
    </div>
    